# -*- coding: utf-8 -*-

import  Synergy.Visual as Visual
from Synergy import Exceptions
from Windows import Dialogs
from . import Logo
import wx.lib.pubsub as pubsub
import wx

class KorespondencjaVisual(Visual.Visual):
    def __init__(self,*args,**kwargs):
        super(KorespondencjaVisual,self).__init__(*args,**kwargs)
        self._Subscribe()

    def _Subscribe(self):
        super(KorespondencjaVisual,self)._Subscribe()
        pubsub.Publisher().subscribe(self.OnDialogEvent, "PostBook.Events.Dialog")


    def OnDialogEvent(self,message):
        if hasattr(self,message.data[0]):
            getattr(self,message.data[0])(*message.data[1:])

    def NewMail(self,*args):
        type = args[0][0]
        titles = {'In': u'Poczta przychodząca', 'Out': u'Poczta wychodząca'}
        bools = {'In': True, 'Out': False}
        dlg=Dialogs.MailDialog(title = titles[type])
        
        if dlg.ShowModal() == wx.ID_OK:
            mail= dlg.GetData()
            mail.SetIncoming(bools[type])
            dlg.Destroy()
            try:
                mail.Save()
            except Exceptions.DatabaseError,error:				
                wiad=u"Pojawił się nieoczekiwany problem z wykoniem zapytania SQL. Szczegóły błędu:\n\n"
                dlg2=wx.MessageDialog(None,wiad+error.message,u"Problem z bazą danych",wx.OK|wx.ICON_ERROR)
                dlg2.ShowModal()
                dlg2.Destroy()
        else:
            dlg.Destroy()

    def UpdateMail(self,*args):
        mail = args[0]
        dlg=Dialogs.MailDialog(mail = mail, title = 'Zmiana informacji o korespondencji')
        
        if dlg.ShowModal() == wx.ID_OK:
            mail= dlg.GetData()
            print 'Mam update, poczta to:',mail.GetData()
            dlg.Destroy()
            try:
                mail.Save()
            except Exceptions.DatabaseError,error:				
                wiad=u"Pojawił się nieoczekiwany problem z wykoniem zapytania SQL. Szczegóły błędu:\n\n"
                dlg2=wx.MessageDialog(None,wiad+error.message,u"Problem z bazą danych",wx.OK|wx.ICON_ERROR)
                dlg2.ShowModal()
                dlg2.Destroy()
        else:
            dlg.Destroy()

        
