# -*- coding: utf-8 -*-
import wx, wx.combo, wx.calendar # do sprawdzenia

from Synergy.Components.Share.Share import StaticSizerWithDifferentControls
from Synergy import Exceptions

from .. import KorespondencjaModel

import wx.lib.masked as masked
import wx.lib.pubsub as pubsub

BOLD_FONT=wx.Font(10, wx.FONTFAMILY_DEFAULT, wx.FONTSTYLE_NORMAL, wx.FONTWEIGHT_BOLD,faceName='Nimbus Sans L')


import  wx.lib.newevent
MailTypeEvent, EVT_MAILTYPE = wx.lib.newevent.NewEvent()


    

class SuggestionListPopup(wx.ListCtrl, wx.combo.ComboPopup):
        
    def __init__(self):
        
        # Since we are using multiple inheritance, and don't know yet
        # which window is to be the parent, we'll do 2-phase create of
        # the ListCtrl instead, and call its Create method later in
        # our Create method.  (See Create below.)
        self.PostCreate(wx.PreListCtrl())

        # Also init the ComboPopup base class.
        wx.combo.ComboPopup.__init__(self)

        self.Bind(wx.EVT_CHAR, self.OnChar)

    def OnChar(self,evt):
        evt.Skip()
       

    def AddManyItems(self,dataList):
        for each in dataList:
            self.AddItem(each)

    def RefreshData(self,dataList):
        self.DeleteAllItems()
        self.AddManyItems(dataList)

    def AddItem(self, txt):
        self.InsertStringItem(self.GetItemCount(), txt)

    def OnMotion(self, evt):
        item, flags = self.HitTest(evt.GetPosition())
        if item >= 0:
            self.Select(item)
            self.curitem = item

    def OnLeftDown(self, evt):
        self.value = self.curitem
        self.Dismiss()


    # The following methods are those that are overridable from the
    # ComboPopup base class.  Most of them are not required, but all
    # are shown here for demonstration purposes.


    # This is called immediately after construction finishes.  You can
    # use self.GetCombo if needed to get to the ComboCtrl instance.
    def Init(self):
        self.value = -1
        self.curitem = -1


    # Create the popup child control.  Return true for success.
    def Create(self, parent):
        wx.ListCtrl.Create(self, parent,
                           style=wx.LC_LIST|wx.LC_SINGLE_SEL|wx.SIMPLE_BORDER)
        self.Bind(wx.EVT_MOTION, self.OnMotion)
        self.Bind(wx.EVT_LEFT_DOWN, self.OnLeftDown)
        return True


    # Return the widget that is to be used for the popup
    def GetControl(self):
        #self.log.write("ListCtrlComboPopup.GetControl")
        return self

    # Called just prior to displaying the popup, you can use it to
    # 'select' the current item.
    def SetStringValue(self, val):
        idx = self.FindItem(-1, val)
        if idx != wx.NOT_FOUND:
            self.Select(idx)

    # Return a string representation of the current item.
    def GetStringValue(self):
        if self.value >= 0:
            return self.GetItemText(self.value)
        return ""

    # Called immediately after the popup is shown
    def OnPopup(self):
        wx.combo.ComboPopup.OnPopup(self)

    # Called when popup is dismissed
    def OnDismiss(self):
        wx.combo.ComboPopup.OnDismiss(self)

    # This is called to custom paint in the combo control itself
    # (ie. not the popup).  Default implementation draws value as
    # string.
    def PaintComboControl(self, dc, rect):
        wx.combo.ComboPopup.PaintComboControl(self, dc, rect)

    # Receives key events from the parent ComboCtrl.  Events not
    # handled should be skipped, as usual.
    def OnComboKeyEvent(self, event):
        wx.combo.ComboPopup.OnComboKeyEvent(self, event)

    # Implement if you need to support special action when user
    # double-clicks on the parent wxComboCtrl.
    def OnComboDoubleClick(self):
        wx.combo.ComboPopup.OnComboDoubleClick(self)

    # Return final size of popup. Called on every popup, just prior to OnPopup.
    # minWidth = preferred minimum width for window
    # prefHeight = preferred height. Only applies if > 0,
    # maxHeight = max height for window, as limited by screen size
    #   and should only be rounded down, if necessary.
    def GetAdjustedSize(self, minWidth, prefHeight, maxHeight):
        return wx.combo.ComboPopup.GetAdjustedSize(self, minWidth, prefHeight, maxHeight)

    # Return true if you want delay the call to Create until the popup
    # is shown for the first time. It is more efficient, but note that
    # it is often more convenient to have the control created
    # immediately.    
    # Default returns false.
    def LazyCreate(self):
        return wx.combo.ComboPopup.LazyCreate(self)

class SuggestionListCtrl2(wx.combo.ComboCtrl):
    def __init__(self,suggestions,*args,**kwargs):
        super(SuggestionListCtrl,self).__init__(*args,**kwargs)
        dummy = SuggestionListPopup()
        self.SetPopupControl(dummy)
        self.suggestions=suggestions
        dummy.AddManyItems(suggestions)
        self.Bind(wx.EVT_TEXT,self.OnText)
        #dummy.AddManyItems(['a','b','c'])

    def OnText(self,event):
        self.ShowPopup()
        print 'nowy texkt'


class SuggestionListCtrlPopup2(wx.PopupTransientWindow):
    """Adds a bit of text and mouse movement to the wx.PopupWindow"""
    def __init__(self, *args,**kwargs):
        super(SuggestionListCtrlPopup,self).__init__(*args,**kwargs)
        self.SetBackgroundColour("#FFB6C1")
        st = wx.StaticText(self, -1,
                          "wx.PopupTransientWindow is a\n"
                          "wx.PopupWindow which disappears\n"
                          "automatically when the user\n"
                          "clicks the mouse outside it or if it\n"
                          "(or its first child) loses focus in \n"
                          "any other way."
                          ,
                          pos=(10,10))
        tc=wx.TextCtrl(self,-1,'')
        sz = st.GetBestSize()
        self.SetSize( (sz.width+20, sz.height+20) )
        self.Bind(wx.EVT_CHAR, self.OnChar)

    def OnChar(self,evt):
        print 'mam char'
        evt.Skip()
        
    def ProcessLeftDown(self, evt):
        return False

    def OnDismiss(self):
        pass




class SuggestionListPopup(wx.ListCtrl, wx.combo.ComboPopup):
        
    def __init__(self):
        
        # Since we are using multiple inheritance, and don't know yet
        # which window is to be the parent, we'll do 2-phase create of
        # the ListCtrl instead, and call its Create method later in
        # our Create method.  (See Create below.)
        self.PostCreate(wx.PreListCtrl())

        # Also init the ComboPopup base class.
        wx.combo.ComboPopup.__init__(self)

        self.Bind(wx.EVT_CHAR, self.OnChar)

    def OnChar(self,evt):
        print 'mam char'
        evt.Skip()

        

    def AddManyItems(self,dataList):
        for each in dataList:
            self.AddItem(each)

    def RefreshData(self,dataList):
        self.DeleteAllItems()
        self.AddManyItems(dataList)

    def AddItem(self, txt):
        self.InsertStringItem(self.GetItemCount(), txt)

    def OnMotion(self, evt):
        item, flags = self.HitTest(evt.GetPosition())
        if item >= 0:
            self.Select(item)
            self.curitem = item

    def OnLeftDown(self, evt):
        self.value = self.curitem
        self.Dismiss()


    # The following methods are those that are overridable from the
    # ComboPopup base class.  Most of them are not required, but all
    # are shown here for demonstration purposes.


    # This is called immediately after construction finishes.  You can
    # use self.GetCombo if needed to get to the ComboCtrl instance.
    def Init(self):
        self.value = -1
        self.curitem = -1


    # Create the popup child control.  Return true for success.
    def Create(self, parent):
        wx.ListCtrl.Create(self, parent,
                           style=wx.LC_LIST|wx.LC_SINGLE_SEL|wx.SIMPLE_BORDER)
        self.Bind(wx.EVT_MOTION, self.OnMotion)
        self.Bind(wx.EVT_LEFT_DOWN, self.OnLeftDown)
        return True


    # Return the widget that is to be used for the popup
    def GetControl(self):
        #self.log.write("ListCtrlComboPopup.GetControl")
        return self

    # Called just prior to displaying the popup, you can use it to
    # 'select' the current item.
    def SetStringValue(self, val):
        idx = self.FindItem(-1, val)
        if idx != wx.NOT_FOUND:
            self.Select(idx)

    # Return a string representation of the current item.
    def GetStringValue(self):
        if self.value >= 0:
            return self.GetItemText(self.value)
        return ""

    # Called immediately after the popup is shown
    def OnPopup(self):
        wx.combo.ComboPopup.OnPopup(self)

    # Called when popup is dismissed
    def OnDismiss(self):
        wx.combo.ComboPopup.OnDismiss(self)

    # This is called to custom paint in the combo control itself
    # (ie. not the popup).  Default implementation draws value as
    # string.
    def PaintComboControl(self, dc, rect):
        wx.combo.ComboPopup.PaintComboControl(self, dc, rect)

    # Receives key events from the parent ComboCtrl.  Events not
    # handled should be skipped, as usual.
    def OnComboKeyEvent(self, event):
        wx.combo.ComboPopup.OnComboKeyEvent(self, event)

    # Implement if you need to support special action when user
    # double-clicks on the parent wxComboCtrl.
    def OnComboDoubleClick(self):
        wx.combo.ComboPopup.OnComboDoubleClick(self)

    # Return final size of popup. Called on every popup, just prior to OnPopup.
    # minWidth = preferred minimum width for window
    # prefHeight = preferred height. Only applies if > 0,
    # maxHeight = max height for window, as limited by screen size
    #   and should only be rounded down, if necessary.
    def GetAdjustedSize(self, minWidth, prefHeight, maxHeight):
        return wx.combo.ComboPopup.GetAdjustedSize(self, minWidth, prefHeight, maxHeight)

    # Return true if you want delay the call to Create until the popup
    # is shown for the first time. It is more efficient, but note that
    # it is often more convenient to have the control created
    # immediately.    
    # Default returns false.
    def LazyCreate(self):
        return wx.combo.ComboPopup.LazyCreate(self)


class SuggestionListCtrlPopup(wx.PopupWindow):
    """Adds a bit of text and mouse movement to the wx.PopupWindow"""
    def __init__(self, parent, style):
        wx.PopupWindow.__init__(self, parent, style)
        #self.suggestionsList=  wx.ListCtrl(self,-1,
        #                   style=wx.LC_LIST|wx.LC_SINGLE_SEL|wx.SIMPLE_BORDER)
        
        self.sl = wx.ListBox(self, -1, choices = ['a','b','c'])
        #sz = self.lb.GetBestSize()
        #self.SetSize((150, 75)) #sz)
        #self.sl.SetSize(self.GetClientSize())
        #self.sl.SetFocus()

        #self.SetBackgroundColour("CADET BLUE")

        #self.tc=wx.TextCtrl(self,-1,'')
        #sz = self.sl.GetBestSize()
        #self.SetSize( (sz.width+20, sz.height+20) )

        #self.Bind(wx.EVT_LEFT_DOWN, self.OnMouseLeftDown)
        #self.Bind(wx.EVT_MOTION, self.OnMouseMotion)
        #self.Bind(wx.EVT_LEFT_UP, self.OnMouseLeftUp)
        #self.Bind(wx.EVT_RIGHT_UP, self.OnRightUp)

        #self.st.Bind(wx.EVT_LEFT_DOWN, self.OnMouseLeftDown)
        self.sl.Bind(wx.EVT_MOTION, self.OnMouseMotion)
        #self.st.Bind(wx.EVT_LEFT_UP, self.OnMouseLeftUp)
        #self.st.Bind(wx.EVT_RIGHT_UP, self.OnRightUp)

        wx.CallAfter(self.Refresh)

    def SetFilter(self,filterr):
        pass
        #print 'Ustawiam etykiete'
        #self.st.SetLabel(self.st.GetLabel()+filterr)
        #self.st.Refresh()
        #self.Refresh()
        #self.Update()

    def OnMouseLeftDown(self, evt):
        self.Refresh()
        self.ldPos = evt.GetEventObject().ClientToScreen(evt.GetPosition())
        self.wPos = self.ClientToScreen((0,0))
        self.CaptureMouse()

    def OnMouseMotion(self, evt):
        print 'ruch nad'
        #if evt.Dragging() and evt.LeftIsDown():
        #    dPos = evt.GetEventObject().ClientToScreen(evt.GetPosition())
        #    nPos = (self.wPos.x + (dPos.x - self.ldPos.x),
        #            self.wPos.y + (dPos.y - self.ldPos.y))
        #    self.Move(nPos)

    def OnMouseLeftUp(self, evt):
        self.ReleaseMouse()

    def OnRightUp(self, evt):
        self.Show(False)
        self.Destroy()


class SuggestionListCtrl(wx.TextCtrl):
    """Adds a bit of text and mouse movement to the wx.PopupWindow"""
    def __init__(self, suggestions,*args,**kwargs):
        super(SuggestionListCtrl,self).__init__(*args,**kwargs)
        self.sl = SuggestionListCtrlPopup(args[0], wx.SIMPLE_BORDER)
        self.on=False
        self.Bind(wx.EVT_TEXT,self.OnText)
        self.Bind(wx.EVT_ENTER_WINDOW,self.OnMouseEntersWindow)
        self.Bind(wx.EVT_LEAVE_WINDOW,self.OnMouseLeavesWindow)
        self.Bind(wx.EVT_ENTER_WINDOW,self.OnMouseEntersWindowList,self.sl)

        #self.Bind(wx.EVT_CHAR, self.OnChar)

    def OnMouseEntersWindow(self,evt):
        print 'muszka w oknie'

    def OnMouseEntersWindowList(self,evt):
        print 'muszka w oknie LISTY'


    def OnMouseLeavesWindow(self,evt):
        print 'muszka w poza oknie'

    def OnChar(self,evt):
        print 'mam char'
        evt.Skip()


    def OnText(self,event):
        print 'rrr'
        if not self.on:
            self.sl.Show(False)
            pos = self.ClientToScreen( (0,0) )
            sz =  self.GetSize()
            self.sl.Position(pos, (0, sz[1]))
            self.sl.Show(True)
            self.on=1
        self.sl.SetFilter('r')

class MailDataField:
    def __init__(self,parent=None):		
        self._ctrls={}				
        self._sizer=wx.BoxSizer(wx.VERTICAL)
        self.parent=parent
        self._model=KorespondencjaModel.KorespondencjaModel()
        self._mail = None
        self._createMailDataField(self._sizer,parent)

    def _createMailDataField(self,sizer,parent):
        """ Creates name, surname, logins and pass fields and add them to the
        sizer        
        """

        date=wx.DateTime()
        date.SetToCurrent()

        currDate=date.GetDateOnly()
        currDate="%s-%s-%s"%(currDate.GetYear(),currDate.GetMonth()+1,currDate.GetDay())
		
        asd = wx.combo.ComboCtrl(self.parent, size=(-1,-1),style=wx.TE_READONLY)
        dummy = DateCtrlComboPopup()
        asd.SetPopupControl(dummy)
        asd.SetValue(currDate)

        nr=self._model.GetLastMailNumber()
        suggestions=self._model.GetKorespondenci()
        labels=((u'Numer', masked.NumCtrl(self.parent, value=nr, integerWidth=5, allowNegative=False), 1, 'nr'),
                (u'Data', asd, 0, 'm_date'),
                (u'Sygnatura',wx.TextCtrl(self.parent, -1, '') , 0, 'signature'),
                #(u'Korespondent', SuggestionListCtrl(suggestions,self.parent,-1) , 0, 'from_to'),
                (u'Korespondent', wx.ComboBox(self.parent,-1,'',choices=suggestions) , 0, 'from_to'),
                (u'Adres', wx.TextCtrl(self.parent, -1, '', style = wx.TE_MULTILINE), 1, 'address'),
                (u'Treść', wx.TextCtrl(self.parent, -1, '', style = wx.TE_MULTILINE), 1, 'topic'),
                )
			
 

        podmiot=StaticSizerWithDifferentControls(self.parent,self._ctrls,labels,'Informacje o korespondencji')
   
        sizer.AddSizer(podmiot,0,flag=wx.GROW|wx.ALL,border=10)		

        self.mt=MailTypesWithBorder(self.parent)
        sizer.Add(self.mt, 0, wx.GROW|wx.ALL,border=10)

        self._ctrls['nr'].Enable(False)

    def ShowData(self,mail):
        self._mail = mail
        data=mail.GetData()
        supportedKeys=self._ctrls.keys()
        for k in data.keys():
            if k in supportedKeys:
                if k == 'm_date':
                    self._ctrls[k].SetValue(str(data[k]))
                else:
                    self._ctrls[k].SetValue(data[k])
        self.mt.SetValue(data['polecony'], data['ZPO'], data['priorytetowy'])

        

    def DataValidator(self,data):
        if not data['from_to'] or not data['topic']:
            raise Exceptions.EmptyData(u'Musisz podać przynajmniej Pełną Nazwę oraz Treść.')
		
    def GetData(self):
        """ Reads alternated user data and returns it in dictionary
        """
        if self._mail:
            reads=self._mail.GetData()
        else:
            reads = {}
        for k in self._ctrls.keys():
            reads[k]=self._ctrls[k].GetValue()

        for each in self.mt.GetData().items():
            reads[each[0]]=each[1]
            
        self.DataValidator(reads) 

        if self._mail:
            return self._mail
        else:
            return KorespondencjaModel.Mail(data = reads)

    def GetSizer(self):
        return self._sizer

        
class MailTypesCheckboxes(object):
    def __init__(self, parent, *args, **kwargs):
        super(MailTypesCheckboxes, self).__init__(*args, **kwargs)
        self.parent=parent
        self.ctrls={}
        self._createCheckBoxes(parent)
        
    def _createCheckBoxes(self, parent):
        typy=(('Polecony','polecony',wx.NewId()),
              ('ZPO','ZPO',wx.NewId()),
              ('Priorytetowy','priorytetowy',wx.NewId()))
        self.zpoID=typy[1][2]
        for each in typy:
            self.ctrls[each[1]] = wx.CheckBox(parent, each[2], each[0])
            self.Add(self.ctrls[each[1]], 1, wx.ALIGN_CENTER_HORIZONTAL|wx.GROW)

        parent.Bind(wx.EVT_CHECKBOX, self.OnCheckbox)

    

    def OnCheckbox(self,evt):
        if evt.GetId()==self.zpoID:
            if self.ctrls['ZPO'].GetValue():
                self.ctrls['polecony'].SetValue(True)
                self.ctrls['polecony'].Enable(False)
            else:
                self.ctrls['polecony'].Enable(True)
                self.ctrls['polecony'].SetValue(False)
        evt = MailTypeEvent()
        #post the event
        self.parent.GetEventHandler().ProcessEvent(evt)

#        print '@@@@@@@@@@@@@', self.ctrls['polecony'].GetValue(), '!!!!!!!!!!!!!!'

            
        
    def Enable(self,state):
        for k in self.ctrls.keys():
            self.ctrls[k].Enable(state)

    def GetData(self):
        ret={}
        for k in self.ctrls.keys():
            ret[k]=self.ctrls[k].GetValue()
        return ret

    def SetValue(self, polecony, ZPO, priorytetowy):
        data = locals()
        data.pop('self')
        for each in data.keys():
            self.ctrls[each].SetValue(data[each])
            
class MailTypesLabels(wx.StaticText):
    def __init__(self, parent, *args, **kwargs):
        super(MailTypesLabels, self).__init__(parent, -1, '')
        self.ctrls={}
        
    def SetValue(self, Polecony, ZPO, Priorytetowy):
        data = locals()
        data.pop('self')
        label = ''
        for each in ('Polecony', 'ZPO', 'Priorytetowy'):
            if data[each]:
                label += each + ' '
        if label == '':
            label=u'Zwykły'
        self.SetLabel(label)

class MailTypesWithBorder(wx.StaticBoxSizer, MailTypesCheckboxes):
    def __init__(self, parent):
        wx.StaticBoxSizer.__init__(self, wx.StaticBox(parent, -1, 'Typy korespondencji'), wx.HORIZONTAL)
        MailTypesCheckboxes.__init__(self, parent)

class MailTypes(wx.BoxSizer, MailTypesCheckboxes):
    def __init__(self, parent):
        #super(MailTypes, self).__init__(parent, -1, wx.HORIZONTAL)
        wx.BoxSizer.__init__(self, wx.HORIZONTAL)
        MailTypesCheckboxes.__init__(self, parent)


# Sprawdzić samego staticBoxa zamiast sizera
class MailInfo(wx.Panel):
    def __init__(self, *args, **kwargs):
        super(MailInfo,self).__init__(*args, **kwargs)
        self.ctrls={}
        self._createInfo()
        
    def _createInfo(self):
        big_sizer = wx.StaticBoxSizer(wx.StaticBox(self, 1, 'Informacje o korespondencji') ,wx.VERTICAL)
        #gbs =  wx.GridBagSizer(5, 3)
        #self.Add(gbs,1,wx.GROW|wx.ALL|wx.ALIGN_CENTER_VERTICAL,border=20)
        info_sizer = wx.BoxSizer(wx.HORIZONTAL)
        sizer = wx.FlexGridSizer(cols = 2, vgap = 1, hgap = 10)
        sizer.AddGrowableCol(1, 1)
        labels=((u'Numer', 'nr','#0e197c'),
                (u'Data', 'm_date','#0e197c'),
                (u'Korespondent','from_to','#0e197c'),
                (u'Sygnatura','signature','#0e197c'),
                (u'Adres', 'address','#0e197c'),
                )

        info_labels = ('Numer', 'Data')

        for each in labels:
            label= wx.StaticText(self, -1, each[0])
            label.SetFont(BOLD_FONT)
            if each[0] in info_labels:
                info_sizer.Add(label, 0, wx.RIGHT,10)
                self.ctrls[each[1]] = wx.StaticText(self, -1, '-')
                info_sizer.Add(self.ctrls[each[1]], 0, wx.EXPAND|wx.RIGHT,10)
            else:
                sizer.Add(label)
                self.ctrls[each[1]] = wx.StaticText(self, -1, '-')
                self.ctrls[each[1]].SetForegroundColour(each[2])
                sizer.Add(self.ctrls[each[1]])

        label= wx.StaticText(self, -1, u'Typ')
        label.SetFont(BOLD_FONT)
        info_sizer.Add(label, 0, wx.RIGHT, 10)
        self.ctrls['typy'] = MailTypesLabels(self)
        info_sizer.Add(self.ctrls['typy'], 0, wx.EXPAND)
        
        big_sizer.Add(info_sizer, 0, wx.LEFT | wx.TOP | wx.RIGHT, 10)
        big_sizer.Add(sizer, 0, wx.LEFT | wx.TOP | wx.RIGHT, 10)

        #gbs.Add((30,0), (0,2))
        label= wx.StaticText(self, -1, u'Treść')
        label.SetFont(BOLD_FONT)
        big_sizer.Add(label, flag = wx.LEFT | wx.RIGHT | wx.TOP, border = 10)
        self.ctrls['topic'] = wx.TextCtrl(self, -1, 'Kliknij na element listy',style=wx.TE_MULTILINE|wx.TE_READONLY|wx.NO_BORDER)
        big_sizer.Add(self.ctrls['topic'], 1, wx.EXPAND | wx.ALL, 10)
        self.SetSizer(big_sizer)


    def ShowData(self,mail):
        #data=locals()
        #data.pop('self')

        data = mail.GetData()
        data['m_date']=str(data['m_date'])
        data['nr']=str(data['nr'])
        
        for k in self.ctrls.keys():
            if k!='topic' and k != 'typy':
                self.ctrls[k].SetLabel(data[k])
            elif k == 'typy':
                self.ctrls[k].SetValue(data['polecony'], data['ZPO'], data['priorytetowy'])
            else:
                self.ctrls[k].SetValue(data[k])
                                     
        self.Layout()



class DateCtrlComboPopup(wx.combo.ComboPopup):

    # overridden ComboPopup methods
    
    def Init(self):
        self.date = None        
        
    def Create(self, parent):
        self.parent=parent
        self.cal = wx.calendar.CalendarCtrl(parent, -1, wx.DateTime_Now(), pos = (1,1),
                    style = wx.calendar.CAL_SHOW_HOLIDAYS
                    | wx.calendar.CAL_SUNDAY_FIRST
                    | wx.calendar.CAL_SEQUENTIAL_MONTH_SELECTION
                    )
        self.cal.Bind(wx.calendar.EVT_CALENDAR,self.OnDatePick,self.cal)
        
        #self.cal.Bind(wx.EVT_MOTION, self.OnMotion)
        #self.cal.Bind(wx.EVT_LEFT_DOWN, self.OnLeftDown)
        

    def GetControl(self):
        return self.cal


    def GetAdjustedSize(self, minWidth, prefHeight, maxHeight):
        return wx.Size(minWidth, min(150, maxHeight))                       

    def GetStringValue(self):
        if self.date:
            return self.date 
        return ""

    def OnLeftDown(self, evt):
        # do the combobox selection
        item, flags = self.tree.HitTest(evt.GetPosition())
        if item and flags & wx.TREE_HITTEST_ONITEMLABEL:
            self.curitem = item
            self.value = item
            self.Dismiss()
        evt.Skip()


    def _parseDate(self,date):	    
	    #return ("%s %s %s")%(date.GetDay(), date.GetMonth()+1, date.GetYear())
	    #return ("%s %s %s")%(date.GetDay(), wx.DateTime_GetMonthName(date.GetMonth()), date.GetYear())
	    return ("%s-%s-%s")%(date.GetYear(), date.GetMonth()+1, date.GetDay())

    def OnDatePick(self,event):
	    self.date=self._parseDate(self.cal.GetDate())
	    #self.date="%s"%(self.cal.GetDate(),)
	    self.Dismiss()
	    event.Skip()

class MailVirtualList(wx.ListCtrl):
    def __init__(self, mail_type=None,*args,**kwargs):	    
	super(MailVirtualList,self).__init__(style=wx.LC_REPORT|wx.LC_VIRTUAL|wx.LC_HRULES|wx.LC_VRULES,*args,**kwargs)	
	self.cachedMail={}
        self._columns_names = None

	self._model=KorespondencjaModel.KorespondencjaModel()
        
	self.currentItem=None
	self._mail_type=mail_type
        self.attr1 = wx.ListItemAttr()
        self.attr1.SetBackgroundColour("yellow")

        self.attr2 = wx.ListItemAttr()
        self.attr2.SetBackgroundColour("#EFEFEF")
	
	self.Bind(wx.EVT_LIST_CACHE_HINT, self.DoCacheItems)
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.OnItemSelected)
        self.Bind(wx.EVT_LIST_ITEM_ACTIVATED, self.OnItemActivated)
        self.Bind(wx.EVT_LIST_ITEM_DESELECTED, self.OnItemDeselected)

	self.Bind(wx.EVT_LIST_ITEM_RIGHT_CLICK, self.OnRightClick)
	#self.Bind(wx.EVT_LIST_ITEM_ACTIVATED, self.OnModifyData)	
	
	self.substring=''
	self.fil_column=0

        self.SetModel()

    def SetModel(self):
	    self._createColumns()
	    self.ShowData()


    def ShowData(self, pol = None, zpo = None, pri = None, start = None, stop = None, search = ''):        
        self.pol = pol
        self.zpo = zpo
        self.pri = pri
        self.start = start
        self.stop = stop
        self.search = search

        self.cachedMail = {}
        self.SetItemCount(self._model.GetMail(pol = pol, zpo = zpo, pri = pri, start = start, stop = stop, search = search,inc=self._mail_type))

        #evt=wx.CommandEvent(wx.wxEVT_COMMAND_LIST_ITEM_SELECTED,self.GetId())
        #self.GetEventHandler().ProcessEvent(evt)

    def _createColumns(self):
            self._columns_names = self._model.GetMailColumnHeaders(True)
	    for col,text in enumerate(self._model.GetMailColumnHeaders()):
		    if col==0:
			    self.InsertColumn(col,text,width=50)
		    elif col<=2:
			    self.InsertColumn(col,text,width=150)
                    else:
                        self.InsertColumn(col,text,width=500)

    def OnItemSelected(self, event):
        self.currentItem = event.m_itemIndex
        event.Skip()#Potrzebne do przetwarzania klikniecia w panelu wyżej

    def OnItemActivated(self, event):
        self.currentItem = event.m_itemIndex

    def getColumnText(self, index, col):
        item = self.GetItem(index, col)
        return item.GetText()

    def OnItemDeselected(self, evt):
	    pass

    def OnRightClick(self, event):
        # only do this part the first time so the events are only bound once
        if not hasattr(self, "popupID1"):
            self.popupID1 = wx.NewId()
            self.Bind(wx.EVT_MENU, self.OnModifyData, id=self.popupID1)

        # make a menu
        menu = wx.Menu()
        # add some items
        menu.Append(self.popupID1, u"Modyfikuj dane")

        # Popup the menu.  If an item is selected then its handler
        # will be called before PopupMenu returns.
        self.PopupMenu(menu)
        menu.Destroy()

    def OnModifyData(self, event):
        mail = self.GetItemData(self.currentItem)
        data=('UpdateMail',mail)
        print 'Wysylam dane do updateu',mail.GetData()
        pubsub.Publisher().sendMessage("PostBook.Events.Dialog",data=data)


    #---------------------------------------------------
    # These methods are callbacks for implementing the
    # "virtualness" of the list...  Normally you would
    # determine the text, attributes and/or image based
    # on values from some external data source, but for
    # this demo we'll just calculate them

    def DoCacheItems(self,evt):
	    for item in range(evt.GetCacheFrom(),evt.GetCacheTo()):
                if not self.cachedMail.has_key(item):
                    self.cachedMail[item] = self._model.GetMail(item=item, pol = self.pol, zpo = self.zpo, pri = self.pri, start = self.start,
                                                                stop = self.stop, search = self.search,inc=self._mail_type)
	    
    def OnGetItemText(self, item, col):
        print self._columns_names,col,self._columns_names[col]
        if not self.cachedMail.has_key(item):
            self.cachedMail[item] = self._model.GetMail(item=item, pol = self.pol, zpo = self.zpo, pri = self.pri, start = self.start,
                                                                stop = self.stop, search = self.search,inc=self._mail_type)
	
        return self.cachedMail[item].GetData()[self._columns_names[col]]
        #return #self._model.GetMail(item=item, pol = self.pol, zpo = self.zpo, pri = self.pri, start = self.start,
                #                                           stop = self.stop, search = self.search, inc = self._mail_type)[col]
                

    def GetItemData(self,item):
        if not self.cachedMail.has_key(item):
            self.cachedMail[item] = self._model.GetMail(item=item, pol = self.pol, zpo = self.zpo, pri = self.pri, start = self.start,
                                                                stop = self.stop, search = self.search,inc=self._mail_type)
        return self.cachedMail[item]
        #return self._model.GetMail(item=item, pol = self.pol, zpo = self.zpo, pri = self.pri, start = self.start,
        #                                                   stop = self.stop, search = self.search, inc = self._mail_type)

    def OnGetItemImage(self, item):
	    return -1


    def OnGetItemAttr(self, item):
        if item % 2 == 1:
            return self.attr2
        elif item % 2 == 0:
            return None#self.attr2
        else:
            return None


class MailPanel(wx.SplitterWindow):
    def __init__(self,parent,id,mail_type,*args,**kwargs):
        super(MailPanel,self).__init__(parent,id, style = wx.SP_LIVE_UPDATE, *args,**kwargs)
        self._init_ctrls(mail_type)

    def _init_ctrls(self,mail_type):
        self.lista=MailVirtualList(parent=self, mail_type=mail_type)
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.OnItemSelected,self.lista)
        self.mailInfo=MailInfo(self)
        self.SetMinimumPaneSize(200)
        self.SplitHorizontally(self.lista, self.mailInfo, 350)

    def OnItemSelected(self,event):
        self.mailInfo.ShowData(self.lista.GetItemData(event.m_itemIndex))
        
    #def SetModel(self,model):
    #    self.lista.SetModel(model)

    def ShowData(self, pol = None, zpo = None, pri = None, start = None, stop = None, search = ''):
        self.lista.ShowData(pol = pol, zpo = zpo, pri = pri, start = start, stop = stop, search = search)

