# -*- coding: utf-8 -*-
import wx
from DataFields import MailDataField


class MailDialog(wx.Dialog):
	def __init__(self,mail = None,*args,**kwargs):
		super(MailDialog,self).__init__(parent=None,style=wx.DEFAULT_DIALOG_STYLE,*args,**kwargs)
		self._sizerVert=wx.BoxSizer(wx.VERTICAL)		
		self._panelCtrls={}
		
		self._init_ctrls(mail)

		self.SetSizer(self._sizerVert)
		self.SetSize((380,self.GetBestSize()[1]))


	def _init_ctrls(self,mail):
		self._panelCtrls['mail_data']=MailDataField(self)
		if mail:
			self._panelCtrls['mail_data'].ShowData(mail)

		self._sizerVert.AddSizer(self._panelCtrls['mail_data'].GetSizer(),0,wx.GROW)		

		b=wx.Button(self,wx.ID_OK)
		b2=wx.Button(self,wx.ID_CANCEL)
		sizer=wx.BoxSizer(wx.HORIZONTAL)
		sizer.Add(b,1,flag=wx.ALL|wx.GROW,border=10)
		sizer.Add(b2,1,flag=wx.ALL|wx.GROW,border=10)
		self._sizerVert.Add(sizer,flag=wx.GROW)
		self.Bind(wx.EVT_BUTTON, self.OnAddButton,b)

	def GetData(self):
		return self._panelCtrls['mail_data'].GetData()

	def OnAddButton(self,event):
		try:
			#For validation
			self.GetData()
			self.EndModal(wx.ID_OK)
		except Exception,error:
			wiad=u"Problem z wprowadzonymi danymi korespondencji. \n \n"
			dlg2=wx.MessageDialog(None,wiad+error.message,u"Problem z danymi",wx.OK|wx.ICON_ERROR)
			dlg2.ShowModal()
			dlg2.Destroy()


	def OnCancelButton(self,event):
		self.EndModal(wx.ID_CANCEL)

class UpdateClientDialog(wx.Dialog):
	def __init__(self,cid,model,*args,**kwargs):
		super(UpdateClientDialog,self).__init__(parent=None,title="Zmiana danych klienta...",style=wx.DEFAULT_DIALOG_STYLE,*args,**kwargs)
		self._sizerVert=wx.BoxSizer(wx.VERTICAL)		

		self._panelCtrls={}
		
		self._init_ctrls(cid,model)

		self.SetSizer(self._sizerVert)
		self.SetSize(self.GetBestSize())


	def _init_ctrls(self,cid,model):
		self._panelCtrls['client data']=ClientDataField(self,model=model)
		self._panelCtrls['client data'].ShowData(cid)
			
		self._sizerVert.AddSizer(self._panelCtrls['client data'].GetSizer(),0,wx.GROW)		

		b=wx.Button(self,wx.ID_OK)
		b2=wx.Button(self,wx.ID_CANCEL)
		sizer=wx.BoxSizer(wx.HORIZONTAL)
		sizer.Add(b,1,flag=wx.ALL|wx.GROW,border=10)
		sizer.Add(b2,1,flag=wx.ALL|wx.GROW,border=10)
		self._sizerVert.Add(sizer,flag=wx.GROW)
		self.Bind(wx.EVT_BUTTON, self.OnAddButton,b)


	def GetData(self):
		return self._panelCtrls['client data'].GetData()

	def OnAddButton(self,event):
		try:
			#For validation
			self.GetData()
			self.EndModal(wx.ID_OK)
		except Exception,error:
			wiad=u"Problem z wprowadzonymi danymi Klienta \n \n"
			dlg2=wx.MessageDialog(None,wiad+error.message,u"Problem z danymi",wx.OK|wx.ICON_ERROR)
			dlg2.ShowModal()
			dlg2.Destroy()


	def OnCancelButton(self,event):
		self.EndModal(wx.ID_CANCEL)
